Subject: bug#60054: 29.0.60; Infinite loop when there are cyclic path in the parse tree

From: Eli Zaretskii <[email-masked]>
Date: Thu, 15 Dec 2022 08:16:39 +0200

> From: Yuan Fu <[email-masked]>
> Date: Wed, 14 Dec 2022 12:27:58 -0800
> Cc: [email-masked]
> 
> >> https://github.com/tree-sitter/tree-sitter-c/issues/119
> >> 
> >> So far, I’ve only observed this in that specific edge case.
> > 
> > We should have protection against that, which should be easy, right?
> 
> Just to make sure, we want to use something like slow-fast pointers, where we have two pointers, and one goes twice as fast, right? That’s the one I was taught in school :-)

No, I mean protect us from inflooping by checking that the parent of a
node is not the node itself.

> In summary, I’m proposing: 
> 1. I add the slow-fast pointer checks in treesit.c and treesit.el
> 2. I replace ts_node_parent/sibling/child with using cursors in tree-traversal functions in treesit.c.

SGTM, thanks.